# NetworkClientListWindow Struct Reference

Main handle for clientlist. More...

Inheritance diagram for NetworkClientListWindow:

## Public Member Functions
| NetworkClientListWindow (const WindowDesc *desc, WindowNumber window_number)
bool | CheckClientListHeight ()
| Finds the amount of clients and set the height correct.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window.
## Data Fields
int | selected_item
uint | server_client_width
uint | company_icon_width

## Detailed Description

Main handle for clientlist.

Definition at line 1976 of file network_gui.cpp.

## Member Function Documentation

virtual void NetworkClientListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 2037 of file network_gui.cpp.

References _dynlang, NetworkClientInfo::client_id, CLIENT_ID_SERVER, NetworkClientInfo::client_name, NetworkClientInfo::client_playas, DrawString(), FONT_HEIGHT_NORMAL, GfxFillRect(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), TD_RTL, DynamicLanguages::text_dir, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

virtual void NetworkClientListWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 2081 of file network_gui.cpp.

References PopupClientList().

virtual void NetworkClientListWindow::OnMouseOver | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

The mouse is currently moving over the window or has just moved outside of the window.

In the latter case pt is (-1, -1).

Parameters:

  | pt | the point inside the window that the mouse hovers over.
  | widget | the widget the mouse hovers over.

Reimplemented from Window.

Definition at line 2089 of file network_gui.cpp.

References FONT_HEIGHT_NORMAL, IsInsideMM(), Window::SetDirty(), WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

virtual void NetworkClientListWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 2029 of file network_gui.cpp.

References CheckClientListHeight(), and Window::DrawWidgets().

virtual void NetworkClientListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 2013 of file network_gui.cpp.

References NetworkClientInfo::client_name, GetSpriteSize(), GetStringBoundingBox(), max(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and Window::width.

The documentation for this struct was generated from the following file:

- src/network/network_gui.cpp